"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = exports.joinDirectoryPath = void 0;
const path_1 = require("path");
function joinPathWithBasePath(filename, directoryPath) {
    return directoryPath + filename;
}
function joinPathWithRelativePath(relativePath) {
    relativePath += relativePath[relativePath.length - 1] === path_1.sep ? "" : path_1.sep;
    return function (filename, directoryPath) {
        return directoryPath.substring(relativePath.length) + filename;
    };
}
function joinPath(filename) {
    return filename;
}
function joinDirectoryPath(filename, directoryPath) {
    return directoryPath + filename + path_1.sep;
}
exports.joinDirectoryPath = joinDirectoryPath;
function build(root, options) {
    const { relativePaths, includeBasePath } = options;
    return relativePaths && root
        ? joinPathWithRelativePath(root)
        : includeBasePath
            ? joinPathWithBasePath
            : joinPath;
}
exports.build = build;
